<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/30/2005 *
 * ================                             Last change: 04/30/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-country.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Country code management                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Laendercode-Management                           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.0.4";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_countries";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_countries (
id BIGINT(20) NOT NULL AUTO_INCREMENT,
code CHAR(2) NOT NULL DEFAULT 'DE',
descr VARCHAR(255) NOT NULL DEFAULT 'Deutschland',
is_active ENUM('Y', 'N') NOT NULL DEFAULT 'N',
KEY(code),
PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_countries (code, descr, is_active) VALUES ('DE', 'Deutschland', 'Y')";

	// Admin menu
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('country', NULL, 'L&auml;ndercodes verwalten', 'Stellen Sie hier L&auml;ndercodes ein, damit auch internationale Mitglieder sich zu Ihrem ".MT_WORD." anmelden k&ouml;nnen.', 8)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('country', 'list_country', 'Verwalten', 'Hinzuf&uuml;gen, &Auml;ndern und L&ouml;schen von L&auml;ndercodes.', 1)";

	// Add entry to user table
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD country_code BIGINT(20) NOT NULL DEFAULT '1'";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_countries";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='country' LIMIT 2";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "SQL-Dateien hinzugef&uuml;gt, die Sie mit z.B. phpMyAdmin einspielen k&ouml;nnen. (DOCS/country/README.de lesen!)";
		break;

	case "0.0.2": // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate: SQL-Anweisungen gesch&uuml;tzt.";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate f&uuml;r die Include-Befehle.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	break;
}

// Language file prefix
$EXT_LANG_PREFIX = "country";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "Y";

//
?>
