<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/11/2004 *
 * ================                             Last change: 11/15/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-payout.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Payout extension                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlung-Erweiterung                           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version of this extension
$EXT_VERSION = "0.3.8";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.1", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8", "0.1.9", "0.2.0", "0.2.1", "0.2.2", "0.2.3", "0.2.4", "0.2.5", "0.2.6", "0.2.7", "0.2.8", "0.2.9", "0.3.0", "0.3.1", "0.3.2", "0.3.3", "0.3.4", "0.3.5", "0.3.6", "0.3.7", "0.3.8");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_payouts";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_user_payouts (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
userid BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
payout_total DOUBLE(22,3) UNSIGNED NOT NULL DEFAULT '0.000',
target_account VARCHAR(255) NOT NULL DEFAULT '',
target_bank VARCHAR(255) NOT NULL DEFAULT '',
payout_id BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
payout_timestamp VARCHAR(10) NOT NULL DEFAULT '0',
status ENUM('NEW', 'ACCEPTED', 'REJECTED') NOT NULL DEFAULT 'NEW',
KEY(userid),
KEY(payout_id),
PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_payout_types";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_payout_types (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
type VARCHAR(255) NOT NULL DEFAULT '',
rate DOUBLE(22,3) UNSIGNED NOT NULL DEFAULT '0.000',
min_points BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('setup', 'config_payouts', 'Auszahlungen', 'Auszahlungsarten einstellen, neu anlegen oder l&ouml;schen.', '15')";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('payouts', 'list_payouts', 'Anfragen auflisten', 'Listet alle Auszahlungsanfragen Ihrer Mitglieder auf.', '16')";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, visible, locked, sort) VALUES('main', 'payout', 'Auszahlungen', 'N', 'N', '11')";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_payouts";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_payout_types";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='payouts'";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE action='main' AND what='payout' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='N' WHERE action='main' AND what='payout' LIMIT 1";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='Y' WHERE action='main' AND what='payout' LIMIT 1";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.1.2": // SQL queries for v0.1.2
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES('payouts', NULL, 'Auszahlungsmanagement', 'Management der Auszahlungsarten.', '8')";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET action='payouts', title='Einstellungen' WHERE action='setup' AND what='config_payouts' LIMIT 1";
		break;

	case "0.1.3": // SQL queries for v0.1.3
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD from_account VARCHAR(255) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD from_pass VARCHAR(255) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD engine_url VARCHAR(255) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD engine_ret_ok VARCHAR(255) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD engine_ret_failed VARCHAR(255) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD pass_enc ENUM('md5', 'base64', 'none') NOT NULL DEFAULT 'md5'";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_payouts ADD password VARCHAR(255) NOT NULL DEFAULT ''";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_payouts ADD target_url LONGBLOB NOT NULL";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_payouts ADD banner_url LONGBLOB NOT NULL";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_payouts ADD link_text VARCHAR(30) NOT NULL DEFAULT ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types ADD allow_url ENUM('Y', 'N') NOT NULL DEFAULT 'N'";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types CHANGE pass_enc pass_enc ENUM('md5', 'base64', 'xxx') NOT NULL DEFAULT 'xxx'";
		break;

	case "0.1.8": // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Auflistung der Auszahlungen ausgelagert in Template <I>member_payout.tpl</I>.";
		break;

	case "0.1.9": // SQL queries for v0.1.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.2.0": // SQL queries for v0.2.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "5 Nachkommastellen implementiert.";
		break;

	case "0.2.1": // SQL queries for v0.2.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_payouts CHANGE payout_total payout_total DOUBLE(22,5) NOT NULL DEFAULT '0.00000'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payout_types CHANGE rate rate DOUBLE(22,5) NOT NULL DEFAULT '0.00000'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Speicherung der Einstellungen beseitigt.";

	case "0.2.2": // SQL queries for v0.2.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Buttons aus Aufgabenauflisten ausgelagert";
		break;

	case "0.2.3": // SQL queries for v0.2.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.";
		break;

	case "0.2.4": // SQL queries for v0.2.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Ausgabe der Auszahlungsm&ouml;glichkeiten im Mitgliedsbereich repariert.";
		break;

	case "0.2.5": // SQL queries for v0.2.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"".SERVER_URL."/patches/340-Gast_Mitgliedsmenue_Deaktivieren.zip\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.2.6": // SQL queries for v0.2.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "IP-Nummer und Browserbezeichnung wird in Admin-Mails eingesetzt.";
		break;

	case "0.2.7": // SQL queries for v0.2.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Link zum Mitgliedsprofil in Funktion <U>ADMIN_USER_PROFILE_LINK()</U> ausgelagert.";
		break;

	case "0.2.8": // SQL queries for v0.2.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Work-Arount-L&ouml;sung zu tempor&auml;ren Problemen mit der Task-ID eingebaut.";
		break;

	case "0.2.9": // SQL queries for v0.2.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Nachricht an Admin bei Auszahlungsanfrage wird endlich versendet.";
		break;

	case "0.3.0": // SQL queries for v0.3.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.";
		break;

	case "0.3.1": // SQL queries for v0.3.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler in Auszahlungsfunktion beseitigt, wenn Umrechnungsrate ungleich 1 eingestellt ist.";
		break;

	case "0.3.2": // SQL queries for v0.3.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.3.3": // SQL queries for v0.3.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Vorbereitung auf die neue Mediendaten v0.0.4.";
		break;

	case "0.3.4": // SQL queries for v0.3.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Anzahl zu &uuml;berweisende {!POINTS!} m&uuml;ssen immer gr&ouml;sser 0 sein, ansonsten bricht das Script mit einer Fehlermeldung an das Mitglied ab.";
		break;

	case "0.3.5": // SQL queries for v0.3.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate f&uuml;r die Include-Befehle.";
		break;

	case "0.3.6": // SQL queries for v0.3.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Hash-Erstellung von <STRONG>md5()</STRONG> auf bessere Funktion <STRONG>generateHash()</STRONG> umgestellt.";
		break;

	case "0.3.7": // SQL queries for v0.3.7
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title = 'Auszahlungsmanagement' WHERE action = 'payouts' AND (what='' OR what IS NULL) LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Verwaltung nach Management umgestellt.";
		break;

	case "0.3.8": // SQL queries for v0.3.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehlerhinweis bei deaktivierter Erweiterung verbessert.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	break;
}
// Language file prefix
$EXT_LANG_PREFIX = "payout";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
