<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/28/2004 *
 * ===============                              Last change: 11/28/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Let's start with the admins table...
if (($cacheInstance->cache_file("admins", true) == true)) {
	// Load cache
	global $cacheArray;
	$cacheArray['admins'] = $cacheInstance->cache_load();

	// Check if valid
	if ((is_array($cacheArray['admins']['login'])) && (is_array($cacheArray['admins']['aid']))) {
		// Check count
		if (count($cacheArray['admins']['login']) == count($cacheArray['admins']['aid'])) {
			//* DEBUG: */ echo "<PRE>";
			//* DEBUG: */ print_r($cacheArray['admins']);

			// The cache file seems to be fine
			foreach ($cacheArray['admins']['login'] as $k=>$login) {
				// Rewrite default_acl
				$cacheArray['admins']['aid'][$login]      = $cacheArray['admins']['aid'][$k];
				$cacheArray['admins']['password'][$login] = $cacheArray['admins']['password'][$k];
				$cacheArray['admins']['email'][$login]    = $cacheArray['admins']['email'][$k];

				// Some extra data depening on version
				if (GET_EXT_VERSION("admins") >= "0.3") {
					$cacheArray['admins']['def_acl'][$login]  = $cacheArray['admins']['def_acl'][$k];
					if (GET_EXT_VERSION("admins") >= "0.6.7") {
						$cacheArray['admins']['la_mode'][$login]  = $cacheArray['admins']['la_mode'][$k];
					}
				}

				//* DEBUG: */ print_r($cacheArray['admins']);

				// Clear array
				if (isset($cacheArray['admins']['aid'][$k])) 		unset($cacheArray['admins']['aid'][$k]);
				if (isset($cacheArray['admins']['def_acl'][$k]))	unset($cacheArray['admins']['def_acl'][$k]);
				if (isset($cacheArray['admins']['la_mode'][$k]))	unset($cacheArray['admins']['la_mode'][$k]);
				if (isset($cacheArray['admins']['password'][$k]))	unset($cacheArray['admins']['password'][$k]);
				if (isset($cacheArray['admins']['email'][$k]))	unset($cacheArray['admins']['email'][$k]);
			}

			//* DEBUG: */ print_r($cacheArray['admins']);

			// Rewrite Login
			foreach ($cacheArray['admins']['login'] as $k=>$login) {
				$cacheArray['admins']['login'][$cacheArray['admins']['aid'][$login]] = $login;
				if (!in_array($k, $cacheArray['admins']['aid'])) {
					unset($cacheArray['admins']['login'][$k]);
				}
			}

			//* DEBUG: */ echo "****\n";
			//* DEBUG: */ print_r($cacheArray['admins']);
			//* DEBUG: */ echo "</PRE>";
			//* DEBUG: */ die();
		} else {
			// Nope, cache file is corrupted!
			$cacheInstance->cache_destroy();
		}
	} else {
		// Nope, cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['admins']);
	}
} elseif (($_CONFIG['cache_admins'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file
	$cacheInstance->cache_init("ADMINS");

	// Load every data from DB to cache file
	$ADD = ", id, id";
	if (GET_EXT_VERSION("admins") >= "0.3")   $ADD  = ", default_acl AS def_acl";
	if (GET_EXT_VERSION("admins") >= "0.6.7") $ADD .= ", la_mode";

	// Query the database about this
	$result_admins = SQL_QUERY("SELECT id AS aid, login, password, email".$ADD."
FROM "._MYSQL_PREFIX."_admins
ORDER BY login", __FILE__, __LINE__);
	while($dummy = SQL_FETCHARRAY($result_admins)) {
		// Save row
		$cacheInstance->add_row($dummy);
	}

	// Free memory
	SQL_FREERESULT($result_admins);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the module registry (mod_reg)...
if ($cacheInstance->cache_file("mod_reg", true) == true) {
	// Load cache
	global $cacheArray;
	$cacheArray['modules'] = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0;
	foreach ($cacheArray['modules'] as $k=>$array) {
		$CNT += count($array);
	}

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['modules']) > 0 ) $TEST = ($CNT / (count($cacheArray['modules'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['modules']);
	} else {
		// Rewrite module cache
		$modArray = $cacheArray['modules'];
		foreach ($modArray['module'] as $key=>$mod) {
			$cacheArray['modules']['id'][$mod] = $modArray['id'][$key];
			unset($cacheArray['modules']['id'][$key]);
			$cacheArray['modules']['title'][$mod] = $modArray['title'][$key];
			unset($cacheArray['modules']['title'][$key]);
			$cacheArray['modules']['locked'][$mod] = $modArray['locked'][$key];
			unset($cacheArray['modules']['locked'][$key]);
			$cacheArray['modules']['hidden'][$mod] = $modArray['hidden'][$key];
			unset($cacheArray['modules']['hidden'][$key]);
			$cacheArray['modules']['admin_only'][$mod] = $modArray['admin_only'][$key];
			unset($cacheArray['modules']['admin_only'][$key]);
			$cacheArray['modules']['mem_only'][$mod] = $modArray['mem_only'][$key];
			unset($cacheArray['modules']['mem_only'][$key]);
			if (isset($cacheArray['modules']['has_menu'][$key])) {
				$cacheArray['modules']['has_menu'][$mod] = $modArray['has_menu'][$key];
				unset($cacheArray['modules']['has_menu'][$key]);
			} // END - if
		}
		unset($modArray);
	}
} elseif (($_CONFIG['cache_modreg'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("MODULES");

	// Load all modules and their data
	if (GET_EXT_VERSION("sql_patches") >= "0.3.6") {
		// Load has_menu
		$result = SQL_QUERY("SELECT id, module, title, locked, hidden, admin_only, title, mem_only, has_menu
FROM "._MYSQL_PREFIX."_mod_reg ORDER BY id", __FILE__, __LINE__);
	} else {
		// Don't load has_menu
		$result = SQL_QUERY("SELECT id, module, title, locked, hidden, admin_only, title, mem_only
FROM "._MYSQL_PREFIX."_mod_reg ORDER BY id", __FILE__, __LINE__);
	}
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the configuration (config)...
if ($cacheInstance->cache_file("config", true) == true) {
	// Load config from cache
	global $cacheArray;
	$cacheArrayConfig = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0; $newCache = array();
	foreach ($cacheArrayConfig as $key=>$array) {
		foreach ($array as $key2=>$value) {
			$newCache[$key2][$key] = $value;
		}
		$CNT += count($array);
	}

	// Overwrite the config with the cache version
	$cacheArray['config'] = $newCache;
	unset($newCache);

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['config']) > 0 ) $TEST = ($CNT / (count($cacheArray['config'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['config']);
	}
} elseif (($_CONFIG['cache_config'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("CONFIG");

	// Load all modules and their data
	$result = SQL_QUERY("SELECT * FROM "._MYSQL_PREFIX."_config ORDER BY config", __FILE__, __LINE__);
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the referral system (refsystem)...
if ($cacheInstance->cache_file("refsystem", true) == true) {
	// Load referral system from cache
	global $cacheArray;
	$cacheArray['ref_system'] = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0;
	foreach ($cacheArray['ref_system'] as $k=>$array) {
		$CNT += count($array);
	}

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['ref_system']) > 0 ) $TEST = ($CNT / (count($cacheArray['ref_system'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['ref_system']);
	}
} elseif (($_CONFIG['cache_refsys'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("refsystem");

	// Load all modules and their data
	$result = SQL_QUERY("SELECT id, userid, level, counter FROM "._MYSQL_PREFIX."_refsystem ORDER BY userid, level", __FILE__, __LINE__);
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the referral system (refdepths)...
if ($cacheInstance->cache_file("refdepths", true) == true) {
	// Load referral system from cache
	global $cacheArray;
	$cacheArray['ref_depths'] = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0;
	foreach ($cacheArray['ref_depths'] as $k=>$array) {
		$CNT += count($array);
	}

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['ref_depths']) > 0 ) $TEST = ($CNT / (count($cacheArray['ref_depths'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['ref_depths']);
	}
} elseif (($_CONFIG['cache_refdepth'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("REFDEPTHS");

	// Load all modules and their data
	$result = SQL_QUERY("SELECT id, level, percents FROM "._MYSQL_PREFIX."_refdepths ORDER BY level", __FILE__, __LINE__);
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

// Next cached table is the referral system (admins_acls)...
if (GET_EXT_VERSION("admins") >= "0.3") {
	// Check for cache file
	if ($cacheInstance->cache_file("admins_acls", true) == true) {
		// Load referral system from cache
		global $cacheArray;
		$cacheArray['admin_acls'] = $cacheInstance->cache_load();

		// Valid cache file
		$CNT = 0;
		foreach ($cacheArray['admin_acls'] as $k=>$array) {
			$CNT += count($array);
		}

		// When there is a period (.) in the result this test will fail and so the cache file is
		// damaged/corrupted
		if (count($cacheArray['admin_acls']) > 0) {
			$TEST = "failed";
			if (count($cacheArray['admin_acls']) > 0 ) $TEST = ($CNT / (count($cacheArray['admin_acls'])));
			if ($TEST != bigintval($TEST)) {
				// Cache file is corrupted!
				$cacheInstance->cache_destroy();
				unset($cacheArray['admin_acls']);
			}
		}
	} elseif (($_CONFIG['cache_acls'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
		// Create cache file here
		$cacheInstance->cache_init("ADMINS_ACLS");

		// Load all modules and their data
		$result = SQL_QUERY("SELECT id, admin_id, action_menu, what_menu, access_mode FROM "._MYSQL_PREFIX."_admins_acls ORDER BY admin_id, action_menu, what_menu", __FILE__, __LINE__);
		while ($DATA = SQL_FETCHARRAY($result)) {
			// Add row to cache file
			$cacheInstance->add_row($DATA);
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Close file
	$cacheInstance->cache_close();
}

//
?>
