<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/01/2008 *
 * ================                             Last change: 09/01/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_surfbar_reflvl.php                     *
 * -------------------------------------------------------------------- *
 * Short description : List referal levels for surfbar                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Referalebenen der Surfbar auflisten              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!is_admin())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} // END - if

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

// Add a level?
if ((isset($_POST['add'])) && (!empty($_POST['lvl'])) && (!empty($_POST['perc']))) {
	// Rewrite percentage and level
	$percent = (float) str_replace(",", ".", $_POST['perc']);
	$level   = bigintval($_POST['lvl']);

	// Add the referal level
	ADMIN_SPONSOR_ADD_REFERAL_LEVEL($levl, $percent);
} // END - if

// Load all referal levels
$result = SQL_QUERY("SELECT id, level, percent FROM "._MYSQL_PREFIX."_surfbar_reflevels ORDER BY level ASC", __FILE__, __LINE__);

// Some levels found?
if (SQL_NUMROWS($result) > 0) {
	// List all levels
	$OUT = ""; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Prepare content
		$content['percent'] = TRANSLATE_COMMA($content['percent']);
		$content['sw'] = $SW;

		// Load row template
		$OUT .= LOAD_TEMPLATE("admin_list_surfbar_reflvl_row", true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - while

	// Load main template
	LOAD_TEMPLATE("admin_list_surfbar_reflvl", false, $OUT);
} else {
	// No level setup so far
	LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_SURFBAR_NO_REF_LEVELS_FOUND);
}

// Free result
SQL_FREERESULT($result);

// Add space
OUTPUT_HTML("<br />");

// Output form for adding new level
LOAD_TEMPLATE("admin_add_surfbar_reflvl");

//
?>
