<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-unconfirmed.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Unconfirmed mails                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbestaetigte Mails                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_LOGGED_IN()) {
	LOAD_URL("modules.php?module=index");
} elseif (!EXT_IS_ACTIVE("mailid")) {
	LOAD_URL("modules.php?module=login");
}

// Add description as navigation point
ADD_DESCR("member", basename(__FILE__));

if (EXT_IS_ACTIVE("bonus")) {
	// Load bonus ID
	$result = SQL_QUERY_ESC("SELECT stats_id, bonus_id, link_type FROM "._MYSQL_PREFIX."_user_links WHERE userid=%s ORDER BY bonus_id DESC",
	 array($GLOBALS['userid']), __FILE__, __LINE__);
} else {
	// Don't load bonus ID
	$result = SQL_QUERY_ESC("SELECT stats_id, stats_id, link_type FROM "._MYSQL_PREFIX."_user_links WHERE userid=%s ORDER BY stats_id DESC",
	 array($GLOBALS['userid']), __FILE__, __LINE__);
}

if (SQL_NUMROWS($result) > 0)
{
	// Please confirm these mails!
	$sum = "0"; $SW = 2; $OUT = "";
	while (list($id, $id2, $type) = SQL_FETCHROW($result))
	{
		// Load data from stats table...
		$cat = "";
		switch ($type)
		{
		case "NORMAL":
			$result_data = SQL_QUERY_ESC("SELECT subject, subject, timestamp_ordered, cat_id, payment_id, pool_id FROM "._MYSQL_PREFIX."_user_stats WHERE id=%s LIMIT 1",
			 array(bigintval($id)), __FILE__, __LINE__);
			$type = "mailid"; $DATA = $id; $PROBLEM = NORMAL_MAIL_PROBLEM;
			break;

		case "BONUS":
			$result_data = SQL_QUERY_ESC("SELECT subject, text, timestamp, cat_id, points, id FROM "._MYSQL_PREFIX."_bonus WHERE id=%s LIMIT 1",
			 array(bigintval($id2)), __FILE__, __LINE__);
			$type = "bonusid"; $DATA = $id2; $PROBLEM = BONUS_MAIL_PROBLEM;
			break;
		}

		if (SQL_NUMROWS($result_data) == 1)
		{
			// Mail was found!
			list($subject, $text, $timestamp, $cat, $pay, $pool) = SQL_FETCHROW($result_data);
			SQL_FREERESULT($result_data);
			if ($type == "NORMAL")
			{
				$pay = GET_PAY_POINTS($pay, "payment");
				$result_text = SQL_QUERY_ESC("SELECT text FROM "._MYSQL_PREFIX."_pool WHERE id=%s LIMIT 1",
				 array(bigintval($pool)), __FILE__, __LINE__);
				list($text) = SQL_FETCHROW($result_text);
				SQL_FREERESULT($result_text);
			}
			if (empty($subject)) $subject = DEFAULT_SUBJECT_LINE;
			if (empty($text))    $text    = "---";
			$subject = COMPILE_CODE($subject);

			// Prepare data for template
			$content = array(
				'sw'     => $SW,
				'uid'    => $GLOBALS['userid'],
				'data'   => $DATA,
				'type'   => $type,
				'subj'   => $subject,
				'text'   => COMPILE_CODE($text),
				'stamp'  => MAKE_DATETIME($timestamp, "0"),
				'cat'    => GET_CATEGORY($cat),
				'points' => TRANSLATE_COMMA($pay),
			);

			// Load row template and count points
			$OUT .= LOAD_TEMPLATE("member_unconfirmed_row", true, $content);
			$sum += $pay;
		}
		 else
		{
			// Prepare data for template
			$content = array(
				'sw'    => $SW,
				'data'  => $DATA,
				'probl' => $PROBLEM,
			);

			// Problem with mail detected
			$OUT .= LOAD_TEMPLATE("member_unconfirmed_404", true, $content);
		}
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);

	// Remember total points
	define('__TOTAL_POINTS', TRANSLATE_COMMA($sum));

	// Remember all generated rows in constant for the template
	define('__UNCONFIRMED_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("member_unconfirmed_table");
}
 else
{
	// No mails left to confirm... :)
	LOAD_TEMPLATE("admin_settings_saved", false, MEMBER_NO_MAILS_TO_CONFIRM);
}

//
?>
