<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/05/2008 *
 * ===============                              Last change: 09/05/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : surfbar.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : The surfbar itself                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Die Surfbar selbst                               *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require_once("inc/libs/security_functions.php");

// Init "action" and "what"
global $what, $action, $startTime, $SURFBAR_CACHE;
$SURFBAR_CACHE = array();
$GLOBALS['startTime'] = microtime(true);
$GLOBALS['what'] = ""; $GLOBALS['action'] = "";

// Set module
$GLOBALS['module'] = "surfbar";
$GLOBALS['refid']  = 0;
$CSS = 0;
$msg = null;

// Load the required file(s)
require ("inc/config.php");

// Is the script installed?
if (defined('mxchange_installed') && (isBooleanConstantAndTrue('mxchange_installed'))) {
	// Only logged in users may use this surfbar!
	if (!IS_LOGGED_IN()) {
		// Redirect
		LOAD_URL(URL."/modules.php?module=index");
	} elseif (!EXT_IS_ACTIVE("surfbar")) {
		// Surfbar deactivated
		LOAD_URL(URL."/modules.php?module=login&msg=".CODE_EXTENSION_PROBLEM);
	}

	// Is there a check value?
	if ((SURFBAR_CHECK_RELOAD_FULL()) || ((isset($_GET['frame'])) && (in_array($_GET['frame'], array("stop", "stop2", "stats", "textlinks"))))) {
		// Reload-lock is full, surfbar stopped so...
		// Load header
		require_once(PATH."inc/header.php");

		// Load template
		if (((isset($_GET['frame'])) && ($_GET['frame'] == "stop")) || (!isset($_GET['frame']))) {
			// Load template for "start" page
			LOAD_TEMPLATE("surfbar_frame_start");

			// Load banner
			OUTPUT_HTML("<br />");
			LOAD_TEMPLATE("surfbar_start_banner");

			// This makes the footer appear again
			unset($_GET['frame']);
		} elseif ((isset($_GET['frame'])) && ($_GET['frame'] == "stats")) {
			// Get total points amount
			$points = GET_TOTAL_DATA($GLOBALS['userid'], "user_points", "points") - GET_TOTAL_DATA($GLOBALS['userid'], "user_data", "used_points");

			// Prepare content
			$content = array(
				'points'   => TRANSLATE_COMMA($points),
				'online'   => SURFBAR_DETERMINE_TOTAL_ONLINE(),
				'reload'   => ($_CONFIG['surfbar_stats_reload'] * 1000),
				'c_total'  => TRANSLATE_COMMA($_CONFIG['surfbar_total_counter']),
				'c_today'  => TRANSLATE_COMMA($_CONFIG['surfbar_daily_counter']),
				'c_yester' => TRANSLATE_COMMA($_CONFIG['surfbar_yester_counter']),
				'c_week'   => TRANSLATE_COMMA($_CONFIG['surfbar_weekly_counter']),
				'c_month'  => TRANSLATE_COMMA($_CONFIG['surfbar_monthly_counter']),
			);

			// Load template for "stats" page
			LOAD_TEMPLATE("surfbar_frame_stats", false, $content);
		} else {
			// Prepare content
			$content = array(
				'restart'   => $_CONFIG['surfbar_restart_time'],
				'start'     => str_repeat("X", strlen($_CONFIG['surfbar_restart_time'])),
				'autostart' => ($_CONFIG['surfbar_autostart'] == "Y") ? "true" : "false"
			);

			// Load template for stopped surfbar
			LOAD_TEMPLATE("surfbar_stopped", false, $content);
		}
	} elseif ((isset($_GET['check'])) && (isset($_GET['id'])) && (isset($_GET['salt']))) {
		// Dummy next id get
		SURFBAR_GET_NEXT_ID($_GET['id']);

		// Check reload lock and validation code
		if ((!SURFBAR_CHECK_RELOAD_LOCK($_GET['id'])) && (SURFBAR_CHECK_VALIDATION_CODE($_GET['id'], $_GET['check'], $_GET['salt']))) {
			// Lock the URL (id) down
			SURFBAR_LOCKDOWN_ID($_GET['id']);

			// Code is valid so pay points here
			SURFBAR_PAY_POINTS($_GET['id']);

			// Check if reload is full
			if (SURFBAR_CHECK_RELOAD_FULL()) {
				// Then load waiting page
				LOAD_URL("surfbar.php?frame=stop");
			} // END - if
		} else {
			// Reload to stop frame!
			LOAD_URL("surfbar.php?frame=stop");
		}

		// All done, so fix notice for footer.php
		$footer = 1;
	} else {
		// Prepare content
		$content = "";

		// Determine template name
		$templateName = SURFBAR_DETERMINE_TEMPLATE_NAME();

		// Frame "top" set?
		if ((isset($_GET['frame'])) && ($_GET['frame'] == "top")) {
			// Determine next id
			$nextId = SURFBAR_GET_NEXT_ID();

			// Is there a valid id?
			if ($nextId > 0) {
				// Then prepare other content
				$content = array(
					'id'          => $nextId,
					'check'       => SURFBAR_GENERATE_VALIDATION_CODE($nextId),
					'salt'        => SURFBAR_GET_SALT(),
					'reward'      => TRANSLATE_COMMA(SURFBAR_GET_REWARD($nextId)),
					'url'         => SURFBAR_GET_URL($nextId),
					'curr_reload' => SURFBAR_GET_USER_RELOAD_LOCK(),
					'max_urls'    => SURFBAR_GET_TOTAL_URLS(),
					'reload'      => SURFBAR_GET_RELOAD_TIME($nextId)
				);

				// Update salt (double-call lock!) and statistics
				SURFBAR_UPDATE_SALT_STATS();
			} else {
				// Load new URL
				LOAD_URL("surfbar.php?frame=stop2");
			}
		} elseif ((isset($_GET['frame'])) && ($_GET['frame'] == "start")) {
			// Starter frame found so let the footer display
			unset($_GET['frame']);
		} else {
			// Load header in frameset mode
			$isFrameset = true;
		}

		// Load header
		require_once(PATH."inc/header.php");

		// Load that template
		//* DEBUG: */ die("templateName={$templateName}<br />\n<strong>content</strong>=<pre>".print_r($content, true)."</pre>");
		LOAD_TEMPLATE($templateName, false, $content);
	}

	// Load footer
	require_once(PATH."inc/footer.php");
} else {
	// You have to configure first!
	LOAD_URL("install.php");
}

// Close any open database connection here
SQL_CLOSE($link, __FILE__, __LINE__);

// Really all done here... ;-)
?>
